<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>LibSylph: Sylph/Core/File.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.8 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="classes.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
    </ul>
  </div>
<h1>Sylph/Core/File.h</h1><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment"> * LibSylph Class Library</span>
<a name="l00003"></a>00003 <span class="comment"> * Copyright (C) 2009 Frank "SeySayux" Erens &lt;seysayux@gmail.com&gt;</span>
<a name="l00004"></a>00004 <span class="comment"> *</span>
<a name="l00005"></a>00005 <span class="comment"> * This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment"> * modify it under the terms of the LibSylph Pulbic License as published</span>
<a name="l00007"></a>00007 <span class="comment"> * by the LibSylph Developers; either version 1.0 of the License, or</span>
<a name="l00008"></a>00008 <span class="comment"> * (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"> *</span>
<a name="l00010"></a>00010 <span class="comment"> * This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the LibSylph</span>
<a name="l00013"></a>00013 <span class="comment"> * Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"> *</span>
<a name="l00015"></a>00015 <span class="comment"> * You should have received a copy of the LibSylph Public License</span>
<a name="l00016"></a>00016 <span class="comment"> * along with this Library, if not, contact the LibSylph Developers.</span>
<a name="l00017"></a>00017 <span class="comment"> *</span>
<a name="l00018"></a>00018 <span class="comment"> * Created on 16 juli 2009, 14:41</span>
<a name="l00019"></a>00019 <span class="comment"> */</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef FILE_H_</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define FILE_H_</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="preprocessor">#include "Object.h"</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include "String.h"</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include "Iterator.h"</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include "Iterable.h"</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Adapted from The Boost Libraries, v1.39.0. Original license follows:</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">//  boost/filesystem/path.hpp  -----------------------------------------------//</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">//  Copyright Beman Dawes 2002-2005</span>
<a name="l00034"></a>00034 <span class="comment">//  Copyright Vladimir Prus 2002</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">//  Distributed under the Boost Software License, Version 1.0. (See accompanying</span>
<a name="l00037"></a>00037 <span class="comment">//  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">//  See library home page at http://www.boost.org/libs/filesystem</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">//  basic_path's stem(), extension(), and replace_extension() are based on</span>
<a name="l00042"></a>00042 <span class="comment">//  basename(), extension(), and change_extension() from the original</span>
<a name="l00043"></a>00043 <span class="comment">//  filesystem/convenience.hpp header by Vladimir Prus.</span>
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">//----------------------------------------------------------------------------//</span>
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 SYLPH_BEGIN_NAMESPACE
<a name="l00048"></a>00048 SYLPH_PUBLIC
<a name="l00049"></a>00049 
<a name="l00053"></a><a class="code" href="class_sylph_1_1_file.html">00053</a> <span class="keyword">class </span><a class="code" href="class_sylph_1_1_file.html">File</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="code" href="class_sylph_1_1_object.html" title="The root of all classes.">Object</a> {
<a name="l00054"></a>00054 <span class="keyword">public</span>:
<a name="l00055"></a>00055 
<a name="l00056"></a>00056     <span class="keyword">class </span>iterator : <span class="keyword">public</span> <a class="code" href="class_sylph_1_1_bidirectional_iterator.html">BidirectionalIterator</a>&lt;String, iterator&gt; {
<a name="l00057"></a>00057     <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="class_sylph_1_1_file.html">File</a>;
<a name="l00058"></a>00058     <span class="keyword">public</span>:
<a name="l00059"></a>00059         <span class="keyword">typedef</span> <a class="code" href="class_sylph_1_1_bidirectional_iterator.html">BidirectionalIterator&lt;String,iterator&gt;</a> super;
<a name="l00060"></a>00060         iterator(<span class="keywordtype">bool</span> begin = <span class="keyword">false</span>, <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>* obj = null);
<a name="l00061"></a>00061         iterator(<span class="keywordtype">bool</span> begin = <span class="keyword">false</span>, <a class="code" href="class_sylph_1_1_file.html">File</a>* obj = null);
<a name="l00062"></a>00062 
<a name="l00063"></a>00063         reference current()<span class="keyword"> const </span>{
<a name="l00064"></a>00064             <span class="keywordflow">return</span> cur;
<a name="l00065"></a>00065         }
<a name="l00066"></a>00066         <span class="keywordtype">void</span> next() <span class="keyword">const</span>;
<a name="l00067"></a>00067         <span class="keywordtype">bool</span> hasNext() <span class="keyword">const</span>;
<a name="l00068"></a>00068 
<a name="l00069"></a>00069         <span class="keywordtype">bool</span> equals(<span class="keyword">const</span> iterator&amp; other)<span class="keyword"> const </span>{
<a name="l00070"></a>00070             <span class="keywordflow">return</span> file == other.file &amp;&amp; cur == other.cur &amp;&amp; pos == other.pos;
<a name="l00071"></a>00071         }
<a name="l00072"></a>00072 
<a name="l00073"></a>00073         iterator(<span class="keyword">const</span> iterator&amp; other) {
<a name="l00074"></a>00074             file = other.file;
<a name="l00075"></a>00075             cur = other.cur;
<a name="l00076"></a>00076             pos = other.pos;
<a name="l00077"></a>00077         }
<a name="l00078"></a>00078         <span class="keywordtype">bool</span> hasPrevious() <span class="keyword">const</span>;
<a name="l00079"></a>00079         <span class="keywordtype">void</span> previous() <span class="keyword">const</span>;
<a name="l00080"></a>00080     <span class="keyword">private</span>:
<a name="l00081"></a>00081         <a class="code" href="class_sylph_1_1_file.html">File</a> * file;
<a name="l00082"></a>00082         <span class="keyword">mutable</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> cur;
<a name="l00083"></a>00083         <span class="keyword">mutable</span> idx_t pos;
<a name="l00084"></a>00084     };
<a name="l00085"></a>00085 
<a name="l00086"></a>00086     S_ITERABLE(<a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a>)
<a name="l00087"></a>00087 <span class="keyword">public</span>:
<a name="l00088"></a>00088 
<a name="l00089"></a>00089     <a class="code" href="class_sylph_1_1_file.html">File</a>() {
<a name="l00090"></a>00090     }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092     <a class="code" href="class_sylph_1_1_file.html">File</a>(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> s) {
<a name="l00093"></a>00093         operator/=(s);
<a name="l00094"></a>00094     }
<a name="l00095"></a>00095     <a class="code" href="class_sylph_1_1_file.html">File</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* s) {
<a name="l00096"></a>00096         operator/=(<a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a>(s));
<a name="l00097"></a>00097     }
<a name="l00098"></a>00098 
<a name="l00099"></a>00099     ~<a class="code" href="class_sylph_1_1_file.html">File</a>() {
<a name="l00100"></a>00100     }
<a name="l00101"></a>00101 
<a name="l00102"></a>00102     <a class="code" href="class_sylph_1_1_file.html">File</a> &amp; removeFilename();
<a name="l00103"></a>00103     <a class="code" href="class_sylph_1_1_file.html">File</a> &amp; replaceExtension(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> newExt = <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a>());
<a name="l00104"></a>00104 
<a name="l00105"></a>00105     <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> toString()<span class="keyword"> const </span>{
<a name="l00106"></a>00106         <span class="keywordflow">return</span> path;
<a name="l00107"></a>00107     }
<a name="l00108"></a>00108 
<a name="l00109"></a>00109     <span class="comment">// file_string</span>
<a name="l00110"></a>00110     <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> nativeString() <span class="keyword">const</span>;
<a name="l00111"></a>00111 
<a name="l00112"></a>00112     <a class="code" href="class_sylph_1_1_file.html">File</a> rootPath() <span class="keyword">const</span>;
<a name="l00113"></a>00113     <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> rootName() <span class="keyword">const</span>;
<a name="l00114"></a>00114     <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> rootDirectory() <span class="keyword">const</span>;
<a name="l00115"></a>00115     <a class="code" href="class_sylph_1_1_file.html">File</a> relativePath() <span class="keyword">const</span>;
<a name="l00116"></a>00116     <a class="code" href="class_sylph_1_1_file.html">File</a> parent() <span class="keyword">const</span>;
<a name="l00117"></a>00117     <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> filename() <span class="keyword">const</span>;
<a name="l00118"></a>00118     <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> stem() <span class="keyword">const</span>;
<a name="l00119"></a>00119     <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> extension() <span class="keyword">const</span>;
<a name="l00120"></a>00120 
<a name="l00121"></a>00121     <span class="keywordtype">bool</span> empty()<span class="keyword"> const </span>{
<a name="l00122"></a>00122         <span class="keywordflow">return</span> path == <span class="stringliteral">""</span>;
<a name="l00123"></a>00123     }
<a name="l00124"></a>00124     <span class="keywordtype">bool</span> complete() <span class="keyword">const</span>;
<a name="l00125"></a>00125     <span class="keywordtype">bool</span> hasRootPath() <span class="keyword">const</span>;
<a name="l00126"></a>00126     <span class="keywordtype">bool</span> hasRootName() <span class="keyword">const</span>;
<a name="l00127"></a>00127     <span class="keywordtype">bool</span> hasRootDirectory() <span class="keyword">const</span>;
<a name="l00128"></a>00128 
<a name="l00129"></a>00129     <span class="keywordtype">bool</span> hasRelativePath()<span class="keyword"> const </span>{
<a name="l00130"></a>00130         <span class="keywordflow">return</span> !relativePath().<a class="code" href="class_sylph_1_1_file.html#22aa131c456ee7fa3986ed361cac9f21">empty</a>();
<a name="l00131"></a>00131     }
<a name="l00132"></a>00132 
<a name="l00133"></a>00133     <span class="keywordtype">bool</span> hasFilename()<span class="keyword"> const </span>{
<a name="l00134"></a>00134         <span class="keywordflow">return</span> path != <span class="stringliteral">""</span>;
<a name="l00135"></a>00135     }
<a name="l00136"></a>00136 
<a name="l00137"></a>00137     <span class="keywordtype">bool</span> hasParent()<span class="keyword"> const </span>{
<a name="l00138"></a>00138         <span class="keywordflow">return</span> !parent().<a class="code" href="class_sylph_1_1_file.html#22aa131c456ee7fa3986ed361cac9f21">empty</a>();
<a name="l00139"></a>00139     }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141     <a class="code" href="class_sylph_1_1_file.html">File</a> &amp; operator=(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> s) {
<a name="l00142"></a>00142         path = <span class="stringliteral">""</span>;
<a name="l00143"></a>00143         operator/=(s);
<a name="l00144"></a>00144         <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00145"></a>00145     }
<a name="l00146"></a>00146 
<a name="l00147"></a>00147     <a class="code" href="class_sylph_1_1_file.html">File</a> &amp; operator/=(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a> &amp; rhs) {
<a name="l00148"></a>00148         <span class="keywordflow">return</span> operator /=(rhs.<a class="code" href="class_sylph_1_1_file.html#996e2de2cc70ca92b1f32f79c37da457">toString</a>());
<a name="l00149"></a>00149     }
<a name="l00150"></a>00150 
<a name="l00151"></a>00151     <a class="code" href="class_sylph_1_1_file.html">File</a> &amp; operator/=(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a>);
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 <span class="keyword">private</span>:
<a name="l00154"></a>00154     <span class="keywordtype">void</span> appendSeparatorIfNeeded();
<a name="l00155"></a>00155     <span class="keywordtype">void</span> append(<a class="code" href="namespace_sylph.html#12380d58a638ec489736d7b60963a34c" title="A integral type for storing an UTF-16 character.">uchar</a> c);
<a name="l00156"></a>00156 
<a name="l00157"></a>00157     <a class="code" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a> path;
<a name="l00158"></a>00158 };
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 <span class="keywordtype">bool</span> <a class="code" href="namespace_sylph.html#10c329a0349416d794bedf8f67feb25f" title="Compares the two Arrays on equality.">operator==</a>(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; rhs);
<a name="l00161"></a>00161 <span class="keywordtype">bool</span> <a class="code" href="namespace_sylph.html#049ea1ef37b015ca0292637e6d2e3ffa" title="Compares the two Arrays.">operator&lt;</a>(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; rhs);
<a name="l00162"></a>00162 <span class="keyword">inline</span> <a class="code" href="class_sylph_1_1_file.html">File</a> operator/(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_file.html">File</a>&amp; rhs) {
<a name="l00163"></a>00163     <span class="keywordflow">return</span> <a class="code" href="class_sylph_1_1_file.html">File</a>(lhs) /= rhs;
<a name="l00164"></a>00164 }
<a name="l00165"></a>00165 <span class="keyword">inline</span> std::ostream&amp; operator&lt;&lt;(std::ostream&amp; lhs, <span class="keyword">const</span> File&amp; rhs) {
<a name="l00166"></a>00166     <span class="keywordflow">return</span> lhs &lt;&lt; rhs.toString();
<a name="l00167"></a>00167 }
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 SYLPH_END_NAMESPACE
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 <span class="preprocessor">#endif  </span><span class="comment">/* FILE_H_ */</span>
<a name="l00172"></a>00172 
</pre></div></div>
<hr size="1" class="unhidden"><address style="text-align: right;"><small>
Documentation for LibSylph by Doxygen
</body>
</html>
